<?php

/**
 * The History abstract class
 *
 * This abstract class must be extended for the DeltaV Versioning Feature
 * It's based on the basic DAV filesystem, but IProperties support is *required*
 * With this you can make your own History filesytem as you want
 *
 * 
 * @package Sabre
 * @subpackage DeltaV
 * @copyright Copyright (C) 2012 PD Programmeur. All rights reserved.
 * @author Pierre Dubois (http://www.pdprogrammeur.com/) 
 * @license http://code.google.com/p/sabredav/wiki/License Modified BSD License
 */
abstract Sabre_DeltaV_Backend_Abstract_History  {
	
	public __contruct($backend){
		// Save the Backend into a local variable
	}

	public function createHistory(){
		// Create a new History Object
		// Return an History Object
	}
	
	
	public function getHistory($uri){
		// Return the "History Manager" for the specified "URI"
	}
	
	public function getCheckedIn($uri){
		// return "DAV:Checkin" value
	}
	
	public function getCheckedOut($uri){
		// return "DAV:Checkout" value
	}
	
	public function isCheckedInOut($uri){
		// return true if either "DAV:Checkin" or "DAV:Checkout" are defined
	}

}	


class Sabre_DeltaV_Ressource {
	
	protected $uri;
	
	public __construct($uri){
		$this->uri = $uri;
	}

	public function checkin(){
		// Can be Stored...
		//	- in the a file system
		//	- in a PDO object (database)
		//	- in a distant non-versioning Webdav server
		
		
		//eg. UPDATE ressource SET 'checkin' = $this->uri
		
		return true; // if succeed
	}
	
	public function checkout(){
		// 1. Get the checkin Value and move it to the checkout eg. SELECT checkin FROM ressource WHERE uri=$this->uri
		// 2. Remove the checkin Value, set the checkout value eg. UPDATE ressource SET 'checkin' = NULL, 'checkout' = $this->uri
		//e
	}

}

class Sabre_DeltaV_VersionRessource {
	
	
}


class Sabre_DeltaV_History {

	public function createVersion($body, $props){
		// Create a new Version are return the URI
		
		// $body = This are the content for the new version to be created
		// $props = This are the properties for the new version to be created
		
	}
}

/*
Property support required in both

+--------+          +--------+
| DAV    |  ----->  | DeltaV |
| Tree   |          | Tree   |
+--------+          +--------+
					(Can be local, external,....)

					*/
?>